/*
 *  Copyright (c) 2014, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.wso2.carbon.apimgt.api.model;

/**
 * This class will hold constants related to key manager de-coupling
 */
public final class  ApplicationConstants {
    public static final String OAUTH_CLIENT_ID = "client_id"; //this means consumer key
    public static final String OAUTH_CLIENT_SECRET = "client_secret";
    public static final String OAUTH_REDIRECT_URIS = "redirect_uris";
    public static final String OAUTH_CALLBACK_URIS = "callback_url";
    public static final String OAUTH_CLIENT_NAME = "client_name";
    public static final String OAUTH_CLIENT_TYPE = "client_type";
    public static final String APP_KEY_TYPE = "key_type";
    public static final String APP_CALLBACK_URL = "callback_url";
    public static final String APP_HOME_PAGE = "homepage";
    public static final String OAUTH_CLIENT_CONTACT = "contact";
    public static final String APP_LOGOURI = "logouri";
    public static final String  OAUTH_CLIENT_SCOPE = "scope";
    public static final String OAUTH_CLIENT_GRANT = "grant_types";
    public static final String OAUTH_CLIENT_RESPONSETYPE = "response_types";
    public static final String OAUTH_CLIENT_AUTHMETHOD = "token_endpoint_auth_method";
    public static final String OAUTH_CLIENT_REGISTRATION_CLIENT_URI = "registration_client_uri";
    public static final String OAUTH_CLIENT_REGISTRATION_ACCESSTOKEN = "registration_access_token";
    public static final String OAUTH_CLIENT_CONTACTS = "contacts";
    public static final String OAUTH_CLIENT_MANUAL = "MANUAL";
    public static final String OAUTH_CLIENT_PRODUCTION = "PRODUCTION";
    public static final String OAUTH_CLIENT_SANDBOX = "SANDBOX";
    public static final String OAUTH_CLIENT_NOACCESSTOKEN = "NO ACCESS TOKEN";
    public static final String OAUTH_CLIENT_JSONPARAMSTRING = "jsonParams";
    public static final String OAUTH_CLIENT_USERNAME = "username";
    public static final String OAUTH_CLIENT_APPLICATION = "application";
    public static final String VALIDITY_PERIOD = "validityPeriod";
    public static final String OAUTH_APP_DETAILS = "appDetails";
    public static final String IMPLICIT_CONST = "implicit";
    public static final String AUTHORIZATION_CODE = "authorization_code";
    public static final String INBOUNT_AUTH_CONSUMER_SECRET = "oauthConsumerSecret";
}
